c...........................................................................
c
      subroutine modgin(ioufh,q3dthk) 
      include 'optim.h'
      common /mod1/ dxm(lx),xc(lx),xe(lx1),dym(ly),yc(ly),ye(ly1)
      common /mod2/ dzm(lxyz),zc(lxyz)
      common /mod3/ ix,iy,iz,ixyz,ixy,iper, izpls
      common /mod4/ pname(nall),ixpnam(nall),iuo(nall),iuv(nall)
      common /unit1/ iu5,iu6,iu7,iu8,iu9,kikoff,iures, iuparm
      common /par5/ work(lxyz),izwrk(lxyz),ptime(msp)
      common /par6/ nzones,nlines,nga
      common /rad1/ iradial
c
      dimension rn(mrnv),lcon(80),tmptim(msp*3)
      character*4 pname   
      character*16 textuh
	character*20 deform
      character*2048 txt,tx2, tx3
	deform = '(145g14.6)'
c
      call ncread(iu9,txt,ierr)
      write(iu5,'(a78)')txt
      call ncread(iu9,txt,ierr)
      write(iu5,'(a78)')txt
c
c   get grid dimension data .......................
c
   5  continue
      call ncread(iu9,txt,ierr)
      if( ierr.lt.0)
     +   stop'  Grid package not found in master model input.'
      call conden(txt,64)
      ki = index(txt,':')+1
      if( ki.lt.2) goto 5
      txt = txt(ki:2048)
c
      iogrd = 98
      call grid(txt, iogrd, iradial, q3dthk)
c
      call  getmat(iu9,n,1,txt)
      itmu = ifrl( work(1) )
      if( itmu.gt.5 .or. itmu.lt.0 .or. n.lt.1 ) itmu = 4
c
c  free format read of stress period specifications to determine iper ....
c
      maxSP3 = msp * 3   
      call  getmat(iu9,n,maxSP3,txt)
      iper = n/3
      if( mod(n,3).gt.0 .or. n.lt.3 )
     +      stop' Error in reading stress periods.'
      do i=1,n
        tmptim(i) = work(i)
      enddo  
      write(iu5,'(8I10)')iz,iy,ix,iper,itmu
c
c  Echo model dimensions to screen
c
      write(*,'(/1x,1hA,3i5,29h <ix, iy, iz> size model with,I4,
     +      16h Stress Periods  /)')ix,iy,iz,iper 
c											    
c   identify units for packages to open and open unformatted files .....
c
      call getiou(iu9, numio, ioufh)
      write(iu5,'(40I3)')(iuv(i),i=1,40)
c
c    identify iapart and istrt
c
      call  getmat(iu9,n,2,txt)
      if( n .lt. 2 ) then
        iapart = 0
        istrt  = 1
      else
        iapart = ifrl( work(1) )
        istrt  = ifrl( work(2) )
      endif
      write(iu5,'(2I10)') iapart, istrt
c
c    goto specialized subroutine that reads in 3-d matricies as a constant,
c  a single layer, a single value for each layer, or a full 3-d matrix.  offer
c  ability to define layers as closed 2-d loops.
c
c  use zones and update it to recover ibound array .............
c
c                input t.bas  
      call zones( iu9,  iu5  )
c
c     assign no-flow head value and starting heads ...........
c
      call ncread(iu9,txt,ierr)
      call qread(rn,1,txt,ierr)
      if( ierr .ne. 0 ) rn(1) = 1234567.
      write(iu5,'(1F10.0)') rn(1)
c
      call ncread(iu9,txt,ierr)
      tx2 = txt
      call caps(tx2,2048)
      ki = index(tx2,'UNIT:') + 5
      if(ki.gt.5) then
        read(tx2(ki:ki+3),'(i4)') kikoff
      else
        kikoff = 39
      endif
      iuo(nall-1) = abs(kikoff)
      iuv(nall-1) = abs(kikoff)
      tx3 = tx2
c
      kg = index(tx2,'GLOBAL:') + 7
      kf = index(tx2,'FILE:')
      if( kf .gt. 0 ) then
        tx2 = txt(kf+5:2048)
      else
        tx2 = 'starting.hd'
      endif
      ki = index(tx2,' ') - 1
      txt = tx2(1:ki)
c
      if(kg.le.7) then
        if( kikoff .lt. 0 ) then
          kikoff = -kikoff
          open(kikoff, file=txt, form='unformatted', status='unknown' )
          do k = 1,iz
            read(kikoff) kstp,kper,pertim,totim,textuh,ncol,nrow,ilay
            ne = k * ixy
            nb = ne - ixy + 1
            read(kikoff) ( work(n), n=nb,ne)
            n = iz*ixy
          enddo
        else
          open(kikoff,file=txt)
          call getmat(kikoff,n,ixyz,txt)
          txt = tx2(1:ki)
        endif
        if(n .ne. ixyz) stop' Insufficient # of starting head values.'
        close(kikoff)
      else
        tx2 = tx3(kg:2048)
        call qread(rn,1,tx2,ierr)
        if(ierr .eq. 1) stop ' No starting head was specified.'
        do i = 1,ixyz
          work(i) = rn(1)
	enddo
      endif
c
      open(kikoff,file=txt)
      do k = 1,iz
        write(iu5,'(I10,F10.2,A20,I10)')kikoff,1.0,deform,-3
        nb = (k-1)*ixy + 1
        ne = k*ixy - ix + 1
        do j = nb,ne,ix
          write(kikoff,deform) (work(i),i=j,j+ix-1)
        enddo
      enddo
      rewind(kikoff)
c
c   apply stress period lengths to iu5 that were pulled earlier.
c
      ptime(1) = 0.0000000
      do i=3,iper*3,3
        ptime(i/3 + 1) = tmptim(i-2) + ptime(i/3)
        mult = tmptim(i-1) + 0.5
	  if( tmptim(i-2).lt.1e8 ) then
	    idig = 8 - alog10(tmptim(i-2))      !!   was 7 
          if( idig.gt.9 ) idig = 9 
          txt(1:20) = '(f10.8,i10,f10.5)               '
          write(txt(6:6),'(i1.1)')  idig
	  else
          txt(1:20) = '(E10.4,i10,f10.5)                '
	  endif
        write(iu5,txt(1:20)) tmptim(i-2),mult,tmptim(i)
      enddo
      rewind(iu5)       
c
c    bcf package should be done since grid file holds dx and dy info.
c  Name and unit number were specified earlier.
c
      nga=0
   50 call ncread(iu9,txt,ierr)
      if( ierr .lt. 0 ) goto 80
      kb = index(txt,'=')
      if( kb .lt. 1 ) goto 50
      tx2 = txt(kb+1:2048)
      call caps(tx2,2048)
      call conden(tx2,64)
c
c      Set io for source modin working file ..................
c
      iumn = iuv( ipoint(tx2,1) ) 
      iu = iuv( ipoint(tx2,1) ) + numio
      rewind(iu)
	if( iu.lt.10+numio .or. iu.gt.39+numio ) then
	  write(*,*)
	  write(*,*)'  Unit number',iumn,' is not between 10 and 39.'
	  write(*,*)
        stop ' Mis-specified unit number.'
      endif  
c
      isp = 1
      if( tx2(1:3) .eq. 'BCF' ) then
        isp = 0
        call ncread(iu9,txt,ierr)
        call caps(txt,2048)
        iss = 1
        if( index(txt,'TRAN') .gt. 0 ) iss = 0
c
c   Warn and stop  if SS model with more than one SP
        if( iss.eq.1 .and. iper.gt.1 ) then
          write(*,*) 
          write(*,*) '  A steady-state model was specified.  ' 
          write(*,*) '  but',iper,' stress periods were assigned.' 
          write(*,*) 
          write(*,*) '   ERROR in either BAS or BCF definition'
          stop '   '
        endif
c
        icbc = 0
        call shorten(txt,'UNIT',4,tx2)
        if( tx2(1:1) .ne. '?' ) then
          call qread(rn,1,tx2,ierr)
          icbc = ifrl( rn(1) )
        endif
c
c   Check for wet/dry info 
        call ncread(iu9,txt,ierr)
        call caps(txt,2048)
        if( index(txt,'WET').gt.0 .or. index(txt,'DRY').gt.0 ) then
         call qread(rn,5,txt,ierr)
	   hdry   = rn(1)
         iwdflg = ifrl(rn(2))
         wetfct = rn(3) 
         iwetit = ifrl(rn(4))
         ihdwet = ifrl(rn(5))
        else
	   backspace( iu9 )
	   hdry   = 0.00
         iwdflg = 0
         wetfct = 0.00
         iwetit = 0
         ihdwet = 0
        endif
c
        write(iu,'(2I10,F10.4,I10,F10.4,2I10)')iss, icbc, hdry, 
     +             iwdflg, wetfct, iwetit, ihdwet
c
c   specify layer type
c
        call ncread(iu9,txt,ierr)
        call qread(rn,iz,txt,ierr)
        do i = 1,iz
          if( i .le. iz-ierr ) then
            lcon(i) = ifrl( rn(i) )
          else
            lcon(i) = 0
          endif
        enddo 
        write(iu,'(40I2)')(lcon(i),i=1,iz)
c
c   define anisotropy ..............
c
        call ncread(iu9,txt,ierr)
        call qread(rn,iz,txt,ierr)
        do i = 1,iz
          if( i .gt. iz-ierr ) rn(i) = 1.0
        enddo 
        write(iu,'(I10,F10.3,A20,I10)')iumn,1.0,deform,0
        write(iu,deform)(rn(i),i=1,iz)
c
c   write dx & dy info from grid package here.
c
        write(iu,'(I10,F10.3,A20,I10)')iumn,1.0,deform,0
        write(iu,deform) (dxm(i),i=1,ix)
        write(iu,'(I10,F10.3,A20,I10)')iumn,1.0,deform,0
        write(iu,deform) (dym(i),i=1,iy)
      else
c
c    write mandatory 2 integers at head of all optional packages.
c
        call ncread(iu9,txt,ierr)
        call qread(rn,2,txt,ierr)
        max  = ifrl( rn(1) )
        icbc = ifrl( rn(2) )
        write(txt(1:20),'(2i10)') max, icbc
        textuh = '(a000)'
        write(textuh(3:5),'(i3.3)') itxend( txt )
        write(iu,textuh) txt
      endif
c
c    identify parameter flags in bcf and other packages to be optimized.
c  all packages were opened earlier.
c     flags are required before all 2-d arrays. if a 3 layer model with 5
c  stress periods(sp) is optimized for t and recharge, a flag is needed for
c  each t array noting its layer and a flag is needed for each unique
c  recharge array noting its layer and sp.  sample flags are:
c
c  tag:transmissivity      layer:2
c  tag:recharge           layer:1    sp:1
c
c    only the first 4 characters in a tag are used to track parameters.
c  case doesn't affect matters since the program capitalizes all tags.
c
c      point value entries require an indicator to flag the field to be
c  optimized.  for wells, q is in the 4th field and the 5th field is
c  conductance in the drain package. lack of a layer flag indicates the
c  following are point values.  the tag line should preceed the line that
c  specifies the number of points in a sp.  if sp is not included, it is
c  assumed that sp = 1.  sample flags are:
c
c     tag:well      field:4
c    tag:drain        field:5    sp:4
c
      ierr = 0
      do while( ierr.eq.0 )
        call ncread(iu9,txt,ierr)
        tx2 = txt
        call caps(txt,2048)
c
c Build a default BCF package from the 3D grid info file 
        if( index(txt,'AUTO').gt.0 .and. isp.eq.0 ) then
          call makBCF(iu,iumn,iss,iradial,q3dthk,lcon,txt)
          ierr = 1
          txt = '                          '
        endif
c
        kb = index(txt,'TAG')
        if( kb .gt. 0 ) then
          call parin(txt,kb,iu,iumn,isp,iradial)
        else
          textuh = '(a000)'
          write(textuh(3:5),'(i3.3)') itxend( tx2 )
          write(iu,textuh) tx2
        endif
      enddo 
      rewind(iu)
c
c check on other packages for optimization
c
      if( ierr .gt. 0) goto 50
c
   80 iuo(nall)=iu5
      close(iu9)
      call unique(nga,nout,pname,ixpnam)
c
c    Report on all zones before returning to optin 
c
c                  t.opt
      call zoneout( iu8 )
c
      return
  99  stop 'HIT END OF FILE WHILE GINNING MODEL.'
      end
c
c....+................................................................
c
      subroutine parin(txt,kb,iu,iumn,isp,iradial)
      include 'optim.h'
      common /mod1/ dxm(lx),xc(lx),xe(lx1),dym(ly),yc(ly),ye(ly1)
      common /mod3/ ix,iy,iz,ixyz,ixy,iper, izpls
      common /mod4/ pname(nall),ixpnam(nall),iuo(nall),iuv(nall)
      common /unit1/ iu5,iu6,iu7,iu8,iu9,kikoff,iures, iuparm
      common /par2/ izone(mgb),igbact(ma,mgb),iglact(ma),ngbpa(ma),
     +              izcube(lxyz) , igbsp(ma,msp)
      common /par5/ work(lxyz),izwrk(lxyz),ptime(msp)
      common /par6/ nzones,nlines,nga
      dimension rn(mrnv)
      character*4 pname
      character*8   frmt
      character*2048 txt,tx2
      pi = 3.141592654
c
c     increment global parameter counter with the assumption this is a new
c  parameter.
c
      nga=nga+1
c
      pname(nga)=txt(kb+4:kb+7)
      iuo(nga)=iu
	if( iu.lt.40 .or. iu.gt.69) then
         	write(*,*)iu,' is not between 40 and 69 ....... '
		stop' No mirror array.'
	endif
c
c    determine if parameter is temporally variable, unlike bcf properties.
c
      if( isp .gt. 0 ) then
        ki = index(txt,'SP:') 
        itime = 1
        if( ki.gt.0 ) then
          tx2 = txt(ki+3:2048)
          call qread(rn,1,tx2,ierr)
	    itime = ifrl( rn(1) )
        endif
      else
        itime = 0
      endif
c
c    determine if parameter is a 2-d array, will have layer specified, or
c  point data ( wells, rivers, drains, and ghb ).
c
      ki = index(txt,'LAYER') + 6
      if( ki .gt. 6 ) then
        tx2 = txt(ki:2048)
        call qread(rn,1,tx2,ierr)
	  k = ifrl( rn(1) )
        call ncread(iu9,txt,ierr)
        call qread(rn,3,txt,ierr)
        kb = index(txt,'(')
        ke = index(txt,')')
        tx2 = txt(kb:ke)//'                            '
        iut = ifrl( rn(1) )
        ip = ifrl( rn(3) )
        write(iu,'(I10,E10.3,A20,I10,A4,2i3)')
     +        iumn,rn(2),tx2,ip,pname(nga),k,itime
        if(iut.gt.0) then
          call  getmat(iu9,n,ixy,txt)
          if( n .ne. ixy ) then
            write(*,*)'  Insufficient values for ',pname(nga),
     +      ' in layer',k
            stop ' Error in data input. '
          endif
        else
          do i = 1,ixy 
            work(i) = 1.000000000000000000
          enddo
        endif
c   If  radial  flow is being simulated  multiply by XC 
        if( iradial.ge.1 ) then
          do n = 1,ixy 
	      i = mod((n-1),ix) + 1 
            work(n) = work(n) * xc(i) * 2 * pi
          enddo
        endif
c
        do nb=1,ixy,ix
          ne=nb+ix-1
          write(iu,tx2)(work(i),i=nb,ne)
        enddo
      else
c
c   read in data from a cell-by-cell list input file ...............
c
        ki = index(txt,'FIELD:') + 6
        tx2 = txt(ki:2048)
        call qread(rn,1,tx2,ierr)
	  lf = ifrl( rn(1) )
        do  j=itime,iper
          call ncread(iu9,txt,ierr)
          if( ierr .ne. 0 ) then
            write(*,'(i5,5h<IERR,a60)') ierr, txt
		  goto 40
          endif
            call qread(rn,1,txt,ierr)
            itmp = ifrl( rn(1) ) 
            write(iu,'(I10,a40,a4,a11,i5,a7,i4)')
     +      itmp,txt(11:50),pname(nga),' --->   SP:',j,' FIELD:',lf
            if( itmp .ge. 0 ) then 
c
c    filter data to fit 10x format ........
c
              do i=1,itmp
               call ncread(iu9,txt,ierr)
               call qread(rn,lf,txt,ierr)
               kk = ifrl( rn(1) )
               jj = ifrl( rn(2) )
               ii = ifrl( rn(3) )
               n = lf - ierr
	         nf = n*10 
               write(txt(1:nf),'(3(i9,1x),10g10.4)') 
     +               kk,jj,ii, (rn(ib), ib=4, n ) 
               frmt = '(a000)'
               write(frmt(3:5),'(i3.3)') itxend( txt )
               write(iu,frmt) txt
c
c     Test for cell-by-cell ZONE modification ..............
c
               call caps(txt,2048)
               ki = index(txt,'ZONE:')
               if( ki.gt.0 ) then 
	           tx2 = txt(ki+5:2048)
                 call qread(rn,1,tx2,ierr)
	           if( rn(2).lt.0.5 .and. ierr.eq.0 ) then  
	             iznew  = ifrl( rn(1) )
                   ki = index(txt,'KOFF:')
                   koff = 0
                   if( ki.gt.0 ) then
                     tx2 = txt(ki+5:2048)
                     call qread(rn,1,tx2,ierr)
                     if( rn(2).lt.0.5 .and. ierr.eq.0 ) koff=ifrl(rn(1))
                   endif
                   node = (kk+Koff-1)*ixy + (jj-1)*ix + ii
	             izold = izcube(node)
	             izcube(node) = iznew
                   write(iu8,'(1x,25HModified zonation <i,j,k>,
     +                  3(i4,1h,), 2h [,i6,6h] from,i5,3h to,i5)') 
     +                    ii, jj, kk, node, izold, izcube(node)
	           endif
	         endif
              enddo
            endif
        enddo
   40   ixpnam(nga)= -1
      endif
c
      return
      end
c
c....+................................................................
c
      subroutine makBCF(iu,iumn,iss,iradial,Q3dthk,lcon,txt)
      include 'optim.h'
      common /mod1/ dxm(lx),xc(lx),xe(lx1),dym(ly),yc(ly),ye(ly1)
      common /mod2/ dzm(lxyz),zc(lxyz)
      common /mod3/ ix,iy,iz,ixyz,ixy,iper, izpls
      common /mod4/ pname(nall),ixpnam(nall),iuo(nall),iuv(nall)
      common /unit1/ iu5,iu6,iu7,iu8,iu9,kikoff,iures, iuparm
      common /par2/ izone(mgb),igbact(ma,mgb),iglact(ma),ngbpa(ma),
     +              izcube(lxyz) , igbsp(ma,msp)
      common /par5/ work(lxyz),izwrk(lxyz),ptime(msp)
      common /par6/ nzones,nlines,nga
      dimension lcon(80)
      character*4 pname, AssTag(3)
      character*2048 txt
c
      data AssTag/'STOR','PERM','VCON'/
      pi = 3.141592654
	itime = 0
c
      npb = iss + 1
      npf = 3
	KxKz = index(txt,'LUMP')   !!  Define T & V with 1 term
c
      do k = 1, iz
	  if( k.eq.iz ) npf = npf - 1
        do np = npb, npf
c
c increment global parameter counter with the assumption this is a new parameter.
          nga=nga+1
          pname(nga) = AssTag(np)
          Lay = k
          if( KxKz.gt.0 .and. np.eq.3 ) then
            pname(nga) = AssTag(np-1)
            Lay = k + iz
          endif
          iuo(nga)  = iu
          if( iu.lt.40 .or. iu.gt.69) then
            write(*,*)iu,' is not between 40 and 69 ....... '
	      stop' No mirror array.'
          endif
c
          txt = '  (145g15.7)  '
          ip = -7
           
          write(iu,'(I10,E10.3,A20,I10,A4,2i3)')
     +        iumn,1.00,txt,ip,pname(nga),Lay,itime
c  Fill with the appropriate thickness info
          km1 = (k-1)*ixy
          km0 = (k-0)*ixy
          if( np.lt.3 ) then
c   Straight thickness for storage and transmissivity
            do i = 1,ixy 
              work(i) = dzm(i+km1)
            enddo
          else
c   Selected inverse thickness for VCON
            do i = 1,ixy 
              bottom = zc(i+km1) - dzm(i+km1)/2 
              topp1  = zc(i+km0) + dzm(i+km0)/2 
              dzgap  = bottom - topp1
              dznode = zc(i+km1) - zc(i+km0)
              if( dzgap .gt. Q3dthk ) then 
c          Quasi 3D interpolation
                work(i) = 1.0 / dzgap
              else
c          3D interpolation
                work(i) = 1.0 / dznode
              endif
            enddo
          endif
c   If  radial  flow is being simulated  multiply by XC 
          if( iradial.ge.1 ) then
            do n = 1,ixy 
              i = mod((n-1),ix) + 1 
              work(n) = work(n) * xc(i) * 2 * pi
            enddo
          endif
c
          do nb=1,ixy,ix
            ne=nb+ix-1
            write(iu,txt)(work(i),i=nb,ne)
          enddo
        enddo    !   End of Property loop 
      enddo    !   end of layer loop
c
      return
      end
c....+................................................................
c
      subroutine aread(kbe,ns,ain,tst,nt)
      parameter ( max = 25)
      dimension kbe(2*max)
      character*4 tst
      character*2048 atxt,ain
c
      atxt = ain
      n = 1
      i = 0
   10 i = i+1
      if( i.ge.2048) goto 15
      if( atxt(i:i) .eq. ' ') then
        atxt(i:i) = '?'
        goto 10
      endif
c
      ki = index(atxt,tst(1:nt))-1
      kbe(2*n-1) = i
      kbe(2*n)   = ki
      i = ki
      n = n+1
      goto 10
c
  15  ns  = n-1
      return
      end
c
c....+....................................................................
c
      integer function ipoint(txt,kb)
	parameter (maxpt=40)
      dimension ltag(maxpt)
      character*4   unitag(maxpt), treq 
      character*2048 txt
c                                 1 1 1 1 1 1 1 1 1 1 2
c               1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0
      data ltag/3,3,2,3,3,3,3,3,3,3,3,2,3,3,4,3,3,3,3,4, 
c               2 2 2 2 2 2 2 2 2 3 3 3 3 3 3 3 3 3 3 4
c               1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0
     +          3,4,3,3,3,3,4,4,3,4,4,4,4,3,4,4,3,4,3,3/
c                    1      2      3      4      5      6      7
      DATA unitag/'BCF?','WEL?','DRN?','RIV?','EVT?','TLK?','GHB?',
c                    8      9     10     11     12     13     14
     1            'RCH?','SIP?','DE4?','SOR?','OC??','PCG?','GFD?',
c                    15     16     17     18     19     20     21
     2            'LRCH','HFB?','RES?','STR?','IBS?','CHD1','FHB?',
c                    22     23     24     25     26     27     28
     3            'VAR1','MNW?','HYD?','TRB?','SGR?','CHD2','CHD3',
c                    29     30     31     32     33     34     35
     4            '    ','    ','    ','    ','    ','    ','    ',
c                    36     37     38     39     40  
     5            '    ','    ','    ','    ','    '/
C     ------------------------------------------------------------------
c
      do i=1, maxpt
        lee = ltag(i)
        ke = kb + lee - 1
        if( txt(kb:ke) .eq. unitag(i)(1:lee)) then 
          ipoint = i
	    return
	  endif
      enddo
c
c    Stop if pointer is not set
c
      treq = txt(kb:kb+3)
      write(*,*) 
      write(*,'(2x,42hThe user requested the MODFLOW file type: ,a4,
     +        24h which is not available.)') treq 
      write(*,*) 
      write(*,*) '   Permissible file types are: ' 
	write(*,'(7(3x,i3,1h:,a4))') 
     +         ( i,unitag(i)(1:ltag(i)), i=1,maxpt)
      write(*,*) 
	stop '     ERROR IN MODFLOW PACKAGE SPECIFICATION. '
c
      return
      end
c
c....+....................................................................
c
      subroutine getiou(io, numio, ioufh)
      include 'optim.h'
      common /mod4/ pname(nall),ixpnam(nall),iuo(nall),iuv(nall)
      dimension kbe(50)
c
      character*2048 txt,tx2
c
      ioufh = 0
      do i=1,nall
        iuv(i) = 0
      enddo
c      
   10 continue
      call ncread(io,txt,ierr)
      tx2 = txt
      call caps(txt,200)
      if( index(txt,'<END>') .ge.1 ) then
        goto 30
      endif
      call aread(kbe,n,txt,' ',1)
      kb = kbe(n*2-1)
        i = ipoint(txt,kb)
        ki = index(txt,':')
        txt(ki:ki) = '?'
        kio = index(txt,':')+1
        read(txt(kio:kio+2),'(i3)') iuv(i)
        ki = index(txt,'FILE')+5
        txt = tx2(ki:2048)
        ki = index(txt,' ') - 1
	  call iotest( iuv(i), txt )
c
c     Open file to be used by MODFLOW and contain modified data sets..
c
        open( iuv(i), file=txt(1:ki) )
        if( i.eq.12 ) then
	    read( iuv(i),'(20x,i10)',err=99,end=99) ioufh
          ioufh = -ioufh
          backspace( iuv(i) )
        endif
c
      if( iuv(i).ge.10 .and. iuv(i).lt.40 ) then
c
c     Open source file to hold original input data ..........
c
          numio = 30
	  write(txt,'(2ht.,i2)' )iuv(i)+numio
          open(iuv(i)+numio,file=txt(1:4))
      endif
      goto 10
  30  k = 49
c
c   read and open unformatted files if they exist.
c
  50  k = k - 1
      call ncread(io,txt,ierr)
      if( ierr.lt.0)
     +   stop'  No data found beyond package identification. '
      tx2 = txt
      call caps(tx2,2048)
      ki = index(tx2,'<END')
      if( ki .gt. 0 ) goto 60
      ki = index(txt,'<')
      if( ki .lt. 1 ) then
   55   backspace(io)
        write(*,*)48-k,' opened as unformatted files.  '
        goto 60
      endif
      ke = index(txt,'>')
      txt(ke:ke+3) = '    '
      read(txt(ki+1:ki+4),'(i4)',err=55) iunit
      iuv(k) = iunit
      ki = index(tx2,'FILE')+5
      txt = txt(ki:2048)
      ki = index(txt,' ') - 1
      open(iunit,file=txt(1:ki),form='UNFORMATTED',err=55)
	if( iunit .eq. abs(ioufh) ) ioufh = abs(ioufh)
      call iotest( iunit, txt )
      goto 50
   60 continue
c
      return
c
   99 stop ' error in OC file.'
      end
c
c....+................................................................
c
      subroutine grid(txt,io,iradial,q3dthk)
      include 'optim.h'
      common /mod1/ dxm(lx),xc(lx),xe(lx1),dym(ly),yc(ly),ye(ly1)
      common /mod2/ dzm(lxyz),zc(lxyz)
      common /mod2aux/ ztop(lxyz),zbot(lxyz)
      common /mod3/ ix,iy,iz,ixyz,ixy,iper, izpls
      common /par5/ work(lxyz),izwrk(lxyz),ptime(msp)
      common /unit1/ iu5,iu6,iu7,iu8,iu9,kikoff,iures, iuparm
      dimension rn(mrnv)
      character*2048 txt
      izpls = 0
c
      open(io,file=txt,status='old',err=99)
c
c   get x-coord info .............
c
      iradial = 0
      call ncread(io,txt,ierr)
      call qread(rn,3,txt,ierr)
c   test for radial flow simulation 
      call caps(txt,2048)
      if( index(txt,'RADIAL') .gt. 0 ) then
        iradial = 1
        ierr    = 2
      endif
      kmu = index(txt,'MULT')
c
      if( ierr .gt. 2)
     +    stop ' NCOL dimension in grid array was not specified'
      ix = ifrl( rn(1) )
      ix1 = ix + 1
      if( ierr.eq.0 ) then 
        xref  = rn(2) 
        ixref = ifrl( rn(3) )
      else
        xref  = 0.0
        ixref = 0
      endif
c
c    Read DX and construct XC and XE data sets 
      call getmat(io,n,ix,txt)
      if( n.ne.1 .and. n.ne.ix .and. kmu.eq.0 ) 
     +    stop ' Number of DX values was not = to 1 or NCOL.'
c
      if( n.gt.1 .and. n.lt.ix .and. kmu.gt.0 ) then
        off = 0.000
        do i = 1, n-2
          off = off + work(i)
        enddo
        cover = work(n) - off
        base  = work(n-1)
        in    = ix - n + 2
        fmult = frcmlt(base,cover,in)
        do i = n, ix 
          work(i) = work(i-1) * fmult
        enddo
        n = ix
      endif
c
      xe(1) = 0.0000
      do i = 1, ix
        imax = mod(i-1,n)+1
        dxm(i) = work(imax)
        xe(i+1) = xe(i) + dxm(i)
      enddo
      do i = 1, ix
        xc(i) = (xe(i) + xe(i+1)) / 2
      enddo
c
      if(ixref.gt.0) then
        dx = xref - xc(ixref) 
        xe(ix+1) = xe(ix+1) + dx
        do i = 1, ix
          xc(i) = xc(i) + dx
          xe(i) = xe(i) + dx
        enddo
      endif
c
c   get y-coord info .............
c
      call ncread(io,txt,ierr)
      call caps(txt,2048)
      kmu = index(txt,'MULT')
      call qread(rn,3,txt,ierr)
      if( ierr .gt. 2)
     +    stop ' NROW dimension in grid array was not specified'
c
      iy = ifrl( rn(1) )
      iy1 = iy + 1
c
      if( iy.gt.1 .and. iradial.eq.1 ) then
	  iradial = 2
      endif
c
      if( ierr.eq.0 ) then 
        yref  = rn(2) 
        iyref = rn(3) + 0.5
      else
        yref  = 0.0
        iyref = 0
      endif
c
c    Read DY and construct YC and YE data sets 
      call  getmat(io,n,iy,txt)
      if( iradial.eq.1 ) work(1) = 1.0000000
      if( n.ne.1 .and. n.ne.iy .and. kmu.eq.0 ) 
     +    stop ' Number of DY values was not = to 1 or NROW.'
c
      if( n.gt.1 .and. n.lt.iy .and. kmu.gt.0 ) then
        off = 0.000
        do i = 1, n-2
          off = off + work(i)
        enddo
        cover = work(n) - off
        base  = work(n-1)
        in    = iy - n + 2
        fmult = frcmlt(base,cover,in)
        do i = n, iy 
          work(i) = work(i-1) * fmult
        enddo
        n = iy
      endif
c
      ye(iy+1) = 0.0000
      do i = iy, 1, -1
        imax = mod(i-1,n)+1
        dym(i) = work(imax)
        ye(i) = ye(i+1) + dym(i)
      enddo
      do i = iy, 1, -1
        yc(i) = (ye(i+1) + ye(i)) / 2
      enddo
c
      if( iyref.gt.0 ) then
        dy = yref - yc(iyref) 
        ye(iy+1) = ye(iy+1) + dy
        do i = iy, 1, -1
          yc(i) = yc(i) + dy
          ye(i) = ye(i) + dy
        enddo
      endif
c
c   get  aquifer thickness information ........
c
c   Number of layers  and additional zone definition layers
c
c   Read more information to define the cut off for Quasi-3D or 3D interpretation of layers
c
c   Specify how  the vertical discretization is to be defined 
c      --  thickness and centroids 
c      --  Tops and Bottoms  
c      --  Contacts 
c          Read by XY / if bottom(k-1) = top(k) 
c    Card w/ BOTTOM & TOP tags will serve instead of repeating the array  
c
c  Set iz = 0 and then read k+1 contacts to define geometry
c
      q3dthk = 1.00
	call ncread(io,txt,ierr)
      call caps(txt,2048)
c
c   If a radial model is constructed in the XY plane, set iz to 1 .........
c
      if( iradial.eq.2 ) then
	  iz = 1
	  izpls = 0
	else
        call qread(rn,3,txt,ierr)
        iz = ifrl( rn(1) )
	endif
c
      ixy  = ix*iy
      ixyz = ixy*iz
c
c  Specify additional zone layers 
	if( ierr.gt.1 .or. iradial.eq.2  ) then
	  izpls = 0
	else
	  izpls = ifrl( rn(2) )
	endif
c
c  Redefine threshold for switching from 3D to Quasi-3D interpretation
	if( ierr.gt.0 .or. iradial.eq.2 ) then
        q3dthk = 1.00
	else
	  q3dthk = rn(3) 
	endif
c
c  Define how the layer information is to be read
c
	if( index(txt,'TOP').gt.0 .and. index(txt,'BOT').gt.0 ) then
c   Read TOPS and BOTTOMS  than calculate DZM and ZC arrays
        izmx = iz
        if(izmx.lt.1) izmx = lx
        iztb = 0
        do while( iztb.lt.izmx ) 
          iztb = iztb + 1
c      Read tops
          call  getmat(io,nn,ixy,txt)
c
          call caps(txt,2048)
          if( index(txt,'TOP').gt.0 .and. index(txt,'BOTTOM').gt.0 
     +         .or. index(txt,'CONTACT').gt.0 ) then
            do i=1,ixy
	        n = (iztb-1)*ixy + i
              ztop(n) = zbot(n-ixy)
            enddo
          elseif( nn.eq.1 ) then
            do i=1,ixy
	        n = (iztb-1)*ixy + i
              ztop(n) = work(1)
            enddo
          elseif( nn.eq.ixy ) then
            do i=1,ixy
	        n = (iztb-1)*ixy + i
              ztop(n) = work(i)
            enddo
          else
	      if( iz.eq.0 ) then
	        izmx = 0
            else
              write(*,*)nn,' values read for contacts from layer',iztb 
              stop'  Error in Top of structure data '
            endif
          endif
c   Read bottoms
          call  getmat(io,nn,ixy,txt)
c
          if( nn.eq.1 ) then
            do i=1,ixy
	        n = (iztb-1)*ixy + i
              zbot(n) = work(1)
            enddo
          elseif( nn.eq.ixy ) then
            do i=1,ixy
	        n = (iztb-1)*ixy + i
              zbot(n) = work(i)
            enddo
          else
	      if( iz.eq.0 ) then
	        izmx = 0
              iztb = iztb - 1
            else
              write(*,*)nn,' values read for contacts from layer',iztb 
              stop'  Error in Bottom of structure data '
            endif
          endif
        enddo
c
        if( iz.eq.0 ) then
	    iz = iztb
          ixyz = ixy*iz
        endif
c   Compute Dzm and ZC from tops and bottoms
        do n = 1,ixyz
          dzm(n) =  ztop(n) - zbot(n)
          zc(n)  = (ztop(n) + zbot(n)) / 2
        enddo
c
	elseif( index(txt,'CONTACT').gt.0 ) then
c   Read IZ+1 contacts and place in ZC array 
        izmx = iz+1
        if(izmx.lt.2) izmx = lx
        iztb = 1
        ipass = 0
        do while( iztb.lt.izmx ) 
c  Read contacts
          call  getmat(io,nn,ixy,txt)
          if( nn.eq.1 ) then
            do i=1,ixy
	        n = (iztb-1)*ixy + i
              zbot(n) = work(1)
            enddo
          elseif( nn.eq.ixy ) then
            do i=1,ixy
	        n = (iztb-1)*ixy + i
              zbot(n) = work(i)
            enddo
          else
	      if( iz.eq.0 ) then
	        izmx = 0
              iztb = iztb - 2
            else
              write(*,*)nn,' values read for contacts from layer',iztb 
              stop'  Error in contacts of structure data '
            endif
          endif
c  Advance layer counter 
          if( ipass.gt.0 ) iztb = iztb + 1
          do i=1,ixy
            n = (iztb-1)*ixy + i
            ztop(n) = zbot(n-ixy*ipass)
          enddo
          ipass = 1
        enddo
c
        if( iz.eq.0 ) then
	    iz = iztb
          ixyz = ixy*iz
        endif
c   Compute Dzm and ZC from tops and bottoms
        do n = 1,ixyz
          dzm(n) =  ztop(n) - zbot(n)
          zc(n)  = (ztop(n) + zbot(n)) / 2
        enddo
c
      elseif( iradial.eq.2 ) then
c   Bypass vertical definition if radial coordinates are used in the XY plane 
        do i=1,ixy
          dzm(i)  = 1.00
          zc(i)   = 0.00
          ztop(i) = 0.50
          zbot(i) =-0.50
        enddo
c
	else
c   Read layer thicknesses (DZM) and centroids (ZC) as 3d matricies
        call  getmat(io,n,ixyz,txt)
c
        if( n.eq.1 ) then
          do i=1,ixyz
            dzm(i) = work(1)
          enddo
        elseif( n.eq.ixyz ) then
          do i=1,ixyz
            dzm(i) = work(i)
          enddo
        elseif( n.eq.iz ) then
          do k=1,iz
            do i=1+(k-1)*ixy,k*ixy
              dzm(i) = work(k)
            enddo
          enddo
        else
	    write(*,*) n,' values were read for thickness.' 
          stop'  Error in thickness data '
        endif
c  Read centroid of layer elevations ........
        call  getmat(io,n,ixyz,txt)
c
        if( n.eq.1 .or. n.eq.ixy ) then
          if( n.eq.1 ) then
            do i=1,ixy
              zc(i) = work(1) - dzm(i)*0.5
            enddo
          else
            do i=1,ixy
              zc(i) = work(i) - dzm(i)*0.5
            enddo
          endif
          do k=2,iz
            do i=1+(k-1)*ixy,k*ixy
              im = i - ixy
              dz = (dzm(i) + dzm(im)) * 0.5
              zc(i) = work(im) - dz
            enddo
          enddo
        elseif( n.eq.iz ) then
          do i=1,ixyz
            kk = (i-1)/ixy + 1
            zc(i) = work(kk)
          enddo
        elseif( n.eq.ixyz ) then
          do i=1,ixyz
            zc(i) = work(i)
          enddo         
        else
          write(*,*) n,' values were read for elevation.' 
          stop'  Error in aquifer elevation data .....'
        endif
c
c    Define tops and bottoms from ZC and DZM
c
        do i = 1,ixyz
          ztop(i) = zc(i) + dzm(i)*0.5
          zbot(i) = zc(i) - dzm(i)*0.5
        enddo         
      endif   !  end of input decsion for vertical discretization 
c
      close(io)
c
c   Test for z-min and z-max ............
c   Perform error check that the bottom of all k nodes are > top of k+1 nodes
c
      zmin = 1.e23
      zmax = -zmin     
      do i=1,ixy
	  kerr = 0
        do k = 1,iz
	    n = (k-1)*ixy + i 
          if( ztop(n).lt.zbot(n) ) kerr = k 
          if( k.lt.iz .and. zbot(n).lt.ztop(n+ixy) ) kerr = -k 
          if( ztop(n).gt.zmax ) zmax = ztop(n)
          if( zbot(n).lt.zmin ) zmin = zbot(n)
        enddo
c	           
        if( kerr.ne.0 ) then 
          write(*,*)
          if(kerr.gt.0 )then
            write(*,*) '  The aquifer	thickness < 0 in layer',kerr
          else
            write(*,*)' Top of layer',-kerr+1,' > the bottom of layer',k
          endif
          write(*,*)
	    stop'     Error in vertical discretization. ' 
        endif
      enddo         
c
c   Report extremes of dimensions.................
c
      write(*,*)
      write(*,'(2x,7hX-min =,f14.2,1h,,3x,7hX-max =,f14.2)')
     +            xe(1),xe(ix+1)
      write(*,'(2x,7hY-min =,f14.2,1h,,3x,7hY-max =,f14.2)')
     +            ye(iy+1),ye(1)
      write(*,'(2x,7hZ-min =,f14.2,1h,,3x,7hZ-max =,f14.2)')
     +            zmin, zmax 
      write(*,*)
c
      write(iu8,*)
      write(iu8,'(2x,7hX-min =,f14.2,1h,,3x,7hX-max =,f14.2)') 
     +            xe(1),xe(ix+1)
      write(iu8,'(2x,7hY-min =,f14.2,1h,,3x,7hY-max =,f14.2)') 
     +            ye(iy+1),ye(1)
      write(iu8,'(2x,7hZ-min =,f14.2,1h,,3x,7hZ-max =,f14.2)') 
     +            zmin, zmax 
      write(iu8,*)
c
      if( xe(ix+1).lt.xe(1) ) stop' Grid file error: Xmax <  Xmin '
      if( ye(1).lt.ye(iy+1) ) stop' Grid file error: Ymax <  Ymin '
      if( zmax.lt.zmin )      stop' Grid file error: Zmax <  Zmin '
c
c   Echo grid definition to auxillary optimization file
c
      txt = 'OUTPUT_old.grd.txt'
      open(io+1, file=txt)
c
      write(io+1,*) ix
      write(io+1,'(6g14.6)') (dxm(i),i=1,ix)
      write(io+1,'(6g14.6)') (xc(i),i=1,ix)
      write(io+1,'(6g14.6)') (xe(i),i=1,ix+1)
      write(io+1,*) iy
      write(io+1,'(6g14.6)') (dym(i),i=1,iy)
      write(io+1,'(6g14.6)') (yc(i),i=1,iy)
      write(io+1,'(6g14.6)') (ye(i),i=1,iy+1)
      write(io+1,*)'  Reservoir Extent ................'
      do j=1,iy
        write(io+1,'(40i2)') (1, i= 1,ix)
      enddo
      write(io+1,*)
c
      write(io+1,*)'     Echo 3d structure data sets  '
      write(io+1,*)
      write(io+1,*)'   Layer thickness  '
      do k = 1,iz
        write(io+1,'(5h#DZM_,i2.2)') k
        do j=1,iy
          ne = (k-1)*ixy + j*ix
		nb = ne -ix +1   
          write(io+1,'(6g14.6)') (dzm(n), n = nb,ne)
        enddo
      enddo
      write(io+1,*)
      write(io+1,*)'   Layer Tops and bottoms  '
      do k = 1,iz
        write(io+1,'(5h#TOP_,i2.2)') k
        do j=1,iy
          ne = (k-1)*ixy + j*ix
		nb = ne -ix +1   
          write(io+1,'(6g14.6)') (ztop(n), n = nb,ne)
        enddo
c
        write(io+1,'(5h#BOT_,i2.2)') k
        do j=1,iy
          ne = (k-1)*ixy + j*ix
		nb = ne -ix +1   
          write(io+1,'(6g14.6)') (zbot(n), n = nb,ne)
        enddo
      enddo
c

      close(io+1)
c
      return
c
c    Stop program if name of 3D-grid file is incorrect.
c
   99 write(*,*)
      write(*,'(2x,18hThe 3D-grid file: ,a30,16h does not exist.)') txt
      write(*,*)
      stop '  MODOPTIM halted in subroutine GRID. '
c
      return
      end
c....+................................................................
c
      subroutine ram3d(x,y,z,inx,iny,inz)
      include 'optim.h'
      common /mod1/ dxm(lx),xc(lx),xe(lx1),dym(ly),yc(ly),ye(ly1)
      common /mod2/ dzm(lxyz),zc(lxyz)
      common /mod3/ ix,iy,iz,ixyz,ixy,iper, izpls
c
      iny = 0
      if( y.lt.ye(iy+1) .or. y.gt.ye(1) )then
        iny = -1
      elseif( iy.eq.1 ) then
        iny = 1
      else
        do i = 1, iy
          if( y.ge.ye(i+1) .and. y.le.ye(i) ) iny = i
        enddo
      endif
c
      inx = 0
      if( x.lt.xe(1) .or. x.gt.xe(ix+1) ) then
        inx = -1
      elseif( ix.eq.1 ) then
        inx = 1
      else
        do i = 1, ix
          if( x.ge.xe(i) .and. x.le.xe(i+1) ) inx = i
        enddo
      endif
      if( inx.lt.0 .or. iny.lt.0 ) goto 30
c
      inz = -1
      if ( iz.eq.1 ) then
        inz = 1
      else
	  k = 0
        do while( k.lt.iz )
          k = k + 1     
          n = ixy*(k-1) + ix*(iny - 1) + inx
          ztop = zc(n) + dzm(n)*0.5
          zbot = ztop - dzm(n)
c         if( z.gt.zbot .and. z.le.ztop ) inz = k
          if( z.gt.zbot ) then
		  inz = k
	      k = iz
          endif
        enddo
      endif
c
   30 return
      end
c
c....+................................................................
c
      subroutine frcass(kzint,x,y,z,n,sum,zero,q3dthk)
      include 'optim.h'
      common /mod1/ dxm(lx),xc(lx),xe(lx1),dym(ly),yc(ly),ye(ly1)
      common /mod2/ dzm(lxyz),zc(lxyz)
      common /mod2a/obfrc(mop3,mobd),kfrc(mop3,mobd),kpotyp(mop)
      common /mod3/ ix,iy,iz,ixyz,ixy,iper, izpls
      common /par2/ izone(mgb),igbact(ma,mgb),iglact(ma),ngbpa(ma),
     +              izcube(lxyz), igbsp(ma,msp)
	sum = -1.0
c
      call ram3d(x,y,z,i,j,k)
      if(i.le.0 .or. j.le.0 .or. k.le.0) return
      k = abs(k)
      nn = ixy*(k-1) + ix*(j-1) + i
      dxc = x - xc(i)
      dyc = y - yc(j)
      dzc = z - zc(nn)  
c
c   Define fraction in the X-direction, set fraction to 0 along edges 
c
      if(i.eq.1.and.dxc.lt.-zero .or. i.eq.ix.and.dxc.gt.zero
     +  .or.  ix.eq.1) then
        xfrac=0.000000000000000000
      else
        if(dxc.lt.0.0) then
          i=i-1
          dxc = x-xc(i)
        endif
        xfrac=dxc/(xc(i+1)-xc(i))
      endif
c
c   Define fraction in the Y-direction, set fraction to 0 along edges  
c
      if(j.eq.1.and.dyc.gt.-zero .or. j.eq.iy.and.dyc.lt.+zero
     +  .or.  iy.eq.1) then
        yfrac=0.0000000000000000000
      else
        if(dyc.lt.0.0) then
          j=j+1
          dyc=y-yc(j)
        endif
        yfrac=dyc/(yc(j-1)-yc(j))
      endif
c
c   Define fraction in the Z-direction, set fraction to 0 along edges  
c   Interpolate from node to node if the top and bottom of adjacent layers
c  are coincident with one another.  Interpolate between layers if quasi-3D
c  assumption has been used.   
c
      if(k.eq.1.and.dzc.gt.zero .or. k.eq.iz.and.dzc.lt.-zero
     +  .or.  iz.eq.1 .or. kzint.eq.0 ) then
        zfrac = 0.0000000000000000000
      else
        nnp1 = nn + ixy
        if(dzc.lt.0.0) then
          k = k+1
          dzc = z - zc(nnp1)
        endif
        bottom = zc(nn)  - dzm(nn)/2 
        topp1  = zc(nnp1)+ dzm(nnp1)/2 
        dzgap  = bottom - topp1
        dznode = zc(nn)  - zc(nnp1)
        if( dzgap .gt. q3dthk ) then 
c      Quasi 3D interpolation
          if( z.ge.bottom ) then 
            zfrac = 0.0000000000000000000
          elseif( z.le.topp1 ) then 
            zfrac = 0.0000000000000000000
            k = k+1
          else
            dzc   = z - topp1
            zfrac = dzc / dzgap
          endif
        else
c      3D interpolation
          zfrac = dzc / dznode
        endif
      endif
c
c    eliminate non-existent cells, izcube = 0
c
      if( izcube(nn) .lt. 1 ) then
        i = 0
        j = 0
        k = 0
        return
      endif
      do l=1,8
        obfrc(n,l)=0.000000000000000
      enddo
c
      l=0
      call node(i,j-1,k,l,ix,iy,iz)
        kfrc(n,1)=l
        if( l.gt.0 ) then         
          if(izcube(l).ne.0) obfrc(n,1) = yfrac *(1.-xfrac) *(1.-zfrac)
        endif  
      l=0
      call node(i+1,j-1,k,l,ix,iy,iz)
        kfrc(n,2)=l
        if( l.gt.0 ) then         
          if(izcube(l).ne.0) obfrc(n,2) = yfrac *xfrac *(1.-zfrac)
        endif  
      l=0
      call node(i,j,k,l,ix,iy,iz)
        kfrc(n,3)=l
        if( l.gt.0 ) then         
          if(izcube(l).ne.0)obfrc(n,3)=(1.-yfrac)*(1.-xfrac) *(1.-zfrac)
        endif  
      l=0
      call node(i+1,j,k,l,ix,iy,iz)
        kfrc(n,4)=l
        if( l.gt.0 ) then         
          if(izcube(l).ne.0) obfrc(n,4)=(1.-yfrac)*xfrac *(1.-zfrac)
        endif  
      l=0
      call node(i,j-1,k-1,l,ix,iy,iz)
        kfrc(n,5)=l
        if( l.gt.0 ) then         
          if(izcube(l).ne.0) obfrc(n,5) = yfrac *(1.-xfrac) * zfrac 
        endif  
      l=0
      call node(i+1,j-1,k-1,l,ix,iy,iz)
        kfrc(n,6)=l
        if( l.gt.0 ) then         
          if(izcube(l).ne.0) obfrc(n,6) = yfrac *xfrac * zfrac 
        endif  
      l=0
      call node(i,j,k-1,l,ix,iy,iz)
        kfrc(n,7)=l
        if( l.gt.0 ) then         
          if(izcube(l).ne.0) obfrc(n,7)=(1.-yfrac)*(1.-xfrac) * zfrac 
        endif  
      l=0
      call node(i+1,j,k-1,l,ix,iy,iz)
        kfrc(n,8)=l
        if( l.gt.0 ) then         
          if(izcube(l).ne.0) obfrc(n,8)=(1.-yfrac)*xfrac * zfrac 
        endif  
c
      sum=0.00000000000000
      do l=1,8
        sum=sum+obfrc(n,l)
      enddo
c 
      if(sum.lt.(1.000000-zero) .and. sum.gt.zero) then
        do l=1,8
          obfrc(n,l) = obfrc(n,l)/sum
        enddo
      endif
c
      return
      end
c
c....+................................................................
C
C NODE:	converts 3-D indices (I,J,K) to 1-D index (N) based on the
C      equation  N = (K-1)*IX*IY + (J-1)*IX + I  or reverts N to (I,J,K).
C
      subroutine node(i,j,k,n,ix,iy,iz)
      kz = iz
      lay = ix * iy
      if(n.lt.1) then
        n=lay*(k-1) + ix*(j-1) + i
      else
        k = (n-1) / lay
        na = n - k * lay
        k = k + 1
        j = (na-1) / ix
        i = na - ix * j
        j = j+1
      endif
      return
      end
c
c..............................................................................
c
      function frcmlt(base,cover,in)
      data close /1.E-6/
c
c   Make a first cut at multiplier ...................
c
      a = 1.00000000000
      frcmlt = a
      rat = cover/base
      if( in .gt. rat ) return
c
      root = 1./in
      a  = alog(rat)/(in*2)
      a  = exp(a)
c
      i = 0
      frc = 0.000
      do while( i.lt.50 .and. abs(frc - 1.).gt. close ) 
        i   = i + 1
        r   = (1.- a**in)/(1.-a)
        frc = (rat/r)**root
        a   =  a * frc
      enddo
      frcmlt = a
c
      return
      end
