c
c_________________________________________________________________________
c
      subroutine output( cormin )
      include 'optim.h'
c
      common /comp1/ xo(mop),yo(mop),zo(mop),TIMo(mop),nobs,kobsbk
      common /comp2/ obs(mop),calc(mop3),calcl(mop),wgt(mop*2),res(mop)
      common /comp3/ well(mop),otype(mop),flxcut(mop), qtest, nqtst
      common /comp4/ wbs(mop), hw(mop), hwl(mop)
      common /unit1/ iu5,iu6,iu7,iu8,iu9,kikoff,iures, iuparm
      common /par1/ parb(ma,mgb),par(ma),ptype(ma),ptag(ma),pinfo(ma)
     +             ,palast(ma)
      common /par1a/ npar,mxgb,cfi
      common /par3/ up(ma),down(ma),smax,step(ma),stfrc
      common /par3a/ rkmin,frcsec
      common /mod2a/obfrc(mop3,mobd),kfrc(mop3,mobd),kpotyp(mop)
      common /mod3/ ix,iy,iz,ixyz,ixy,iper, izpls
c
      common /grad1/ gr1(ma),gr1l(ma),grss(mop,ma),fir(ma,ma)
      common /grad2/ gr2(ma),secd(ma,ma),wk(ma,ma)
      common /grad3/ dp(ma),rhs(ma),tm2(ma,ma),ipo,ipl
      common /grad4/ err,err0,rmse,errdiv,iter,errl,avg,sdev
      common /grad5/ yts,stws,gtp,gtpl
      common /choke1/ lab(ma)
	common /oc1/ wminoc, iblank
	common /gwmgt1/  qwtst, liftst, nqwtst, nlftst, MNWtst, nMNWtst 
	common /sclout/ timref, timscl, wlmlt, wlref, 
     +                qmlt, qwmlt, cstmlt, idatim
c
      dimension   rank(ma), igrmx(ma), igmx2(ma) 
      dimension   a(ma,ma), cc(ma,ma)
      character*1  tab
      character*4  otype,ptype,ptag,pinfo, qtest, qwtst, liftst
      character*4  MNWtst 
      character*10 date
      character*16 Atime
      character*64 well
      character*2048 txt 
	data errBEST, zero /1.0E31, 1e-16/
	errmax = 0.01
	tab = char(9)
c
      if( iter.gt.0 ) then
c
c    Compute  normalized rank of parameters
c
        do i = 1, npar
          rank(i) = ( fir(i,i) / fir(1,1) )**0.5
	    grmax = 0.0000
          igrmx(i) = 1
          igmx2(i) = 1
	    do j = 1, nobs
	      if( abs(grss(j,i)) .gt. grmax ) then
              grmax = abs(grss(j,i))
              igmx2(i) = igrmx(i)
              igrmx(i) = j
            endif
          enddo
        enddo
c
        veclen = 0.000000
        dismax = 0.000000
        do i=1,ipo
          dstp2  = dp(i)**2 
          veclen = veclen + dstp2 
          if( dstp2.gt.dismax ) dismax = dstp2
        enddo
        dismax = dismax**0.5
        veclen = veclen**0.5
	endif
c
c   Latest residual and sensitivity values  
c
      Kloop = 1  
c   Skip update section if error increases.
      if( iter.eq.0 .or. err.lt.errBEST ) then
        rewind(iures)
        rewind(iuParm)
        errBEST = err
        Kloop = 2  
c
c   Report WL values first  errors and sensitivities on big line
c
c     Header for locating items
        write(iures,206) (j,tab,j=1,18),(ptype(j),tab, j= 1,npar)
        write(iures,202) (tab,j=1,18),   (ptag(j),tab, j= 1,npar)
c
  206 format(18(i2.2,a1), 200(a4,a1) ) 
  202 format(5hOtype,a1,'No.',a1,'Time',a1,'Simulated',a1,'Measured',
     + a1,'Wgt*Resid',a1,'-Weight',a1,'+Weight',a1,'X-pt',a1,
     + 'SITE-ID',a1,'WBS',a1,'X',a1,'Y',a1,'Z',a1,'I',a1,'J',
     + a1,'K',a1,'NODE',a1,200(a4,a1))  
c
        do i=1,nobs
          iprint = 1  
          if( otype(i)(1:nqtst) .eq. qtest(1:nqtst) ) iprint = 0
          if( obfrc(i,2) .gt. 999 ) iprint = 0
          if( wgt(i)+wgt(i+mop) .lt. wminoc ) iprint = 0
          if( iprint .gt. 0 )  then
            if( i.gt.1 .and. i.gt.1 .and. iblank.eq.1 ) then 
              if( well(i).ne.well(i-1) )  write(iures,*)
            endif  
            nd =  kfrc(i,3)
            call node(ii,jj,kk,nd,ix,iy,iz)
            wt = wgt(i+nsign(res(i))*mop)  
c
            time = TIMo(i)/timscl + timref
            if( idatim.gt.0 ) then
              iday = time	       
              call int2date(iday,date)
	        Atime = ' '//date//'   '
c           12/45/7890 23:45:78
            else
	        write(Atime,'(g16.8)') time 
            endif 
c
            obmult = wlmlt
            obref = wlref
            if( otype(i)(1:nqtst)  .eq. qtest(1:nqtst) ) then
              obmult = qmlt
              obref  = 0.00
            endif
            if( otype(i)(1:nqwtst) .eq. qwtst(1:nqwtst)  ) then
              obmult = qwmlt
              obref  = 0.00
            endif
            if( otype(i)(1:nlftst) .eq. liftst(1:nlftst) ) then
              obmult = cstmlt
              obref  = 0.00
            endif
c
            oc = calc(i)/obmult + obref 
            om = obs(i) /obmult + obref 
c
            write(iures,201)otype(i),tab,i,tab,Atime,tab,oc,tab,om,tab,
     +          wt*res(i),tab,wgt(i),tab,wgt(i+mop),tab,kpotyp(i),tab,
     +          well(i),tab,wbs(i),tab,xo(i),tab,yo(i),tab,zo(i),tab,
     +          ii,tab,jj,tab,kk,tab,nd,tab, (grss(i,j),tab,j=1,npar)
          endif
        enddo
  201 format(a4,a1, i7,a1, a20,a1, 3(g16.8,a1), 2(g10.3,a1), i4, a1, 
     +       a12, a1, 4(g15.8,a1), 3(i5,a1), i7,a1, 200(g14.6,a1))
c
c    Report Flow rates ................
c
c   Remove FLOW RATE tag ----  
c        write(iures,'(/,
c     +    48h  FLOW RATES, AVERAGE QW, and TOTAL LIFT -------,/)')
c        write(iures,202)
c
        do i=1,nobs
          iprint = 0  
          if( otype(i)(1:nqtst) .eq. qtest(1:nqtst) ) then
            iprint = 1
          endif
          if( otype(i)(1:nqwtst) .eq. qwtst(1:nqwtst)
     +        .and. obfrc(i,2).gt.999               )  then
            iprint = 1
          endif
          if( otype(i)(1:nlftst).eq.liftst(1:nlftst)
     +        .and. obfrc(i,2).gt.999               )  then
            iprint = 1
          endif
          if( wgt(i)+wgt(i+mop) .lt. wminoc ) iprint = 0
          if( iprint .gt. 0 )  then
            obmult = wlmlt
            obref = wlref
            if( otype(i)(1:nqtst)  .eq. qtest(1:nqtst)   ) then
              obmult = qmlt
              obref  = 0.00
            endif
            if( otype(i)(1:nqwtst) .eq. qwtst(1:nqwtst)  ) then
              obmult = qwmlt
              obref  = 0.00
            endif
            if( otype(i)(1:nlftst) .eq. liftst(1:nlftst) ) then
              obmult = cstmlt
              obref  = 0.00
            endif
c
            if( i.gt.1 .and. well(i).ne.well(i-1) .and. iblank.eq.1 ) 
     +        write(iures,*)
            wt = wgt(i+nsign(res(i))*mop)  
c
	      time = TIMo(i)/timscl + timref
            if( idatim.gt.0 ) then
              iday = time	       
              call int2date(iday,date)
              Atime = ' '//date//'    '
            else
	        write(Atime,'(g16.8)') time 
            endif 
c
            oc = calc(i)/obmult + obref 
            om = obs(i) /obmult + obref 
            write(iures,201)otype(i),tab,i,tab,Atime,tab,oc,tab,om,tab,
     +          wt*res(i),tab,wgt(i),tab,wgt(i+mop),tab,kpotyp(i),tab,
     +          well(i),tab, (0,tab, j=1,8), (grss(i,j),tab,j=1,npar)
          endif
        enddo
      endif   !! End of residual/sensitivity update section 
c
c   Report overall error statistics and parameter estimates 
c   First pass is to MAIN file -- Second is to Best Estimate file
c   Skip update section if error increases.
c
      do kprt = 1, Kloop  
        iotemp = iu8
        if( kprt .eq. 2 ) iotemp = iuParm
c
        write(iotemp,'(a10,a1,i10)') 'Iteration:',tab,iter
        write(iotemp,'(a18,a1,i10)') 'Active Parameters:',tab,ipo
        write(iotemp,'(a21,a1,f9.3)')'MAX Parameter Change:',tab,dismax
        write(iotemp,'(a21,a1,f9.3)')'NET Parameter Change:',tab,veclen
c
c    Report Weighted & Unweighted statistics by Observation type --------
c
        call ErrorByType(otype, res, wgt, nobs, iotemp )
c
c
        write(iotemp,102) 'Parameter Number',tab,'Unique Tag',tab,
     +    'INPUT Type',tab,'Lower Bound',tab,'Parameter Estimate',tab,
     +    'Upper Bound',tab,'Parameter Change',tab,
     +    'Gradient X Residual',tab,'Relative Sensitivity',tab,
     +    'Maximum Gradient',tab,'MaxGrad / 2ndMaxGrad',tab,
     +    'Observation Number',tab,'Site-ID'
  102   format(a16,a1,a10,a1,a10,a1,a11,a1,a18,a1,a11,a1,a16,a1,a19,
     +         a1,a20,a1,a16,a1,a20,a1,a18,a1,a7) 
c 
        do i=1,npar
          d = down(i)
          p = parval(down(i),par(i),up(i),pinfo(i))
          u = up(i)
          if(pinfo(i)(4:4).eq.'S') u = u + d
          if(pinfo(i)(3:3).eq.'E') then
            d = 10.00**d
            u = 10.00**u
          endif
c  How many times greater is the dominant observation than the 2nd greatest observation? 
          times = 1.000
          iPT = 1
          if( igmx2(i).ge.1 ) then
            iPT = igrmx(i)
            if( abs(grss(igmx2(i),i)) .gt. zero ) then
              times = grss(igrmx(i),i) / grss(igmx2(i),i) 
            endif
          endif
c 
          write(iotemp,110)i,tab,ptag(i),tab,ptype(i),tab,
     +      d,tab,p,tab,u,tab,dp(i),tab,gr1(i),tab, rank(i),tab,
     +      grss(iPT,i),tab,times,tab,iPT,tab, well(iPT)
c  Consider identifying 2nd greatest
        enddo
  110   format(i5,2(a1,a4),8(a1,g14.6), a1,i7,a1, a32) 
        write(iotemp,*)
c
c    Report "measure of redundancy / Fischer Information matrix" statistics  
c
        txt = 'Measure_of_Redundancy'
        call FImatrix(grss, a, cc, nobs, ipo )
        call corrma(CC,ptag,ipo,iotemp,txt)
        call corank(CC,rank,ptag,ipo,iotemp,txt,cormin)
c
c    Report "Correlation Coefficient / Fischer Information matrix" statistics  
c
        call FIMinverse( a, CC, ipo, sqrmse )
        if( sqrmse.lt.errmax .and. cc(1,1).gt.0 ) then     
          txt='RMS_error_between_F-1_X_F_and_I_matricies: '
          write(iotemp,'(/3x,a45,a1,f11.7/)') txt, tab, sqrmse
          txt = ' Correlation_Coefficients '
          call corrma(CC,ptag,ipo,iotemp,txt)
          call corank(CC,rank,ptag,ipo,iotemp,txt,cormin)
        else
          write(iotemp,*)'Inverse of Fischer Information matrix failed.' 
        endif 
      enddo   !!  End of print loop for 2X pass 
c
c
      return
      end
c
c_________________________________________________________________________
ca
      subroutine corank(a,rank,tag,np,iu,txt,cutoff)
      include 'optim.h'
      dimension a(ma,ma), b(ma*ma), nl(ma*ma), rank(ma),iv(ma*ma)
      character*1  tab
      character*4 tag(ma)
      character*80 txt, txtout
	tab = char(9)
c
	npair = 0 
c
      txtout = '"'//txt
	ki = index(txtout,'    ') + 2
	txtout(ki:ki+1) = '>'//tab
	write(txtout(ki+2:ki+7),'(f5.2)') cutoff
      write(iu,'(//a80)') txtout
c
c    Parameter pairs > cutoff are identified and listed from greatest to least.
c
      do i = 2, np 
        do j = 1, i-1
          ccof = a(i,j) 
	    if( abs(ccof) .gt. cutoff) then
	      npair = npair + 1
	      b(npair) = ccof
	      nl(npair) = (i-1)*np + j
	      iv(npair) = npair
	    endif
        enddo 
      enddo 
c
c    Sort values 
c
      do i = 1, npair-1
        do j = 1, npair-1
          m  = iv(j)
          m1 = iv(j+1)
          if( abs(b(m)) .lt. abs(b(m1)) ) then
            iv(j)=m1
            iv(j+1)=m
          endif
	  enddo
	enddo
c
c    Write results to residual file
c
      write(iu,'(23h"Pairs of parameters =",a1,i6/)') tab, npair
      txtout = '"'//txt
	ki = index(txtout,'    ') + 1
	txtout(ki:80) = '"'//tab//'Tag1'//tab//'[RS1]'//tab//':'//tab//
     +               'Tag2'//tab//'[RS2]'
	write(iu,'(a80)') txtout
c
	do iuns = 1,npair 
	  is = iv(iuns)
	  n = nl(is)
 	  i = (n-1)/np + 1
	  j = n - (i-1)*np
	  write(iu,'(f6.3,a1,a4,a1,f5.3,a1,a1,a1,a4,a1,f5.3)')   
     +   b(is),tab, tag(j),tab, rank(j),tab,':',tab,tag(i),tab,rank(i)
	enddo
c
      return
      end
c
c_________________________________________________________________________
c
      subroutine corrma(a,tag,np,iu,defin)
      include 'optim.h'
      dimension a(ma,ma)
      character*1  tab
      character*4 tag(ma)
      character*2048 defin
	tab = char(9)
	nsec = 220
      zero = 1.e-8
c
c   Report matrix with parameters scaled from -1 to 1
c   Either Measure of redundancy   or  correlation coefficients
c
      write(iu,'(/1h",a40,1h")')defin
 
      do isc = 1, np, nsec
        do i = isc, np
          ne = i 
          nex = isc + nsec - 1 
          if( ne .gt. nex ) ne = nex 
          write(iu,'(A4,120(a1,F6.2))') tag(i),(tab,a(i,j),j=isc,ne )
        enddo 
        ne = isc + nsec - 1 
        if( ne .gt. np ) ne = np
        write(iu,'(4h/\->,220(a1,A4))') (tab,tag(j),j = isc,ne)
        write(iu,*)
      enddo 
c
      return
      end
c_________________________________________________________________________
c
      subroutine matout(a,n,iu)
      include 'optim.h'
      dimension a(ma,ma)
      character*1  tab
	tab = char(9)
c
      do i=1,n
        write(iu,'(266(g12.5,a1))')(a(i,j),tab,j=1,n)
      enddo
c
      return
      end
c
c_________________________________________________________________________
c
      subroutine FImatrix(grss, a, CC, nobs, np )
      include 'optim.h'
      dimension grss(mop,ma), a(ma,ma), CC(ma,ma)
      zero=1.e-8
c
      do i=1, np
        do j = 1, np
          sum = 0.00000
          do n = 1, nobs
            sum  = sum + grss(n,i) * grss(n,j)
          enddo 
          a(i,j) = sum 
        enddo 
      enddo 
c
      call CCorrS(a, CC, np )
c
      return
      end
c
c_________________________________________________________________________
c
      subroutine FIMinverse( a, CC, np, sqrmse )
      include 'optim.h'
      dimension a(ma,ma), CC(ma,ma)
      double precision a0(ma,ma),c(ma,ma), b(ma,ma), indx(ma), sum
      zero = 1.e-10
c
      do i=1, np
        do j = 1, np
          c(i,j)  = a(i,j) 
          a0(i,j) = a(i,j) 
		b(i,j)  = 0.00000000
        enddo 
        c(i,i) = c(i,i) + c(1,1) * zero
	  b(i,i) = 1.0000
      enddo 
c
	call ludcmp(c,np,indx,det)
	if( det.lt.-9999 ) then
 	  cc(1,1) = -1 
        return 
      endif 
c
	do j = 1,np
	  call lubksb(c,np,indx,b(1,j))
      enddo
c
c  Multiply inverse by original to test that the identity matrix is produced
c
      do i=1, np
        do j = 1, np
          sum=0.000000000000000000
          do ism = 1,np
            sum = sum + b(i,ism)*a0(ism,j)
          enddo  
          a(i,j) = sum 
        enddo
      enddo 
c
c   Solve for RMS error difference between  Identity and  a matricies
c
      sqrmse = rmsidm(a,np)
c
c   Compute correlation coefficients 
c
      do i=1, np
        do j = 1, np
          a(i,j) = b(i,j) 
        enddo 
      enddo 
c
      call CCorrS(a, CC, np )
c
      return
      end
c
c_________________________________________________________________________
c
      subroutine CCorrS(a, CC, np )
      include 'optim.h'
      dimension  a(ma,ma), CC(ma,ma)
      zero = 1.e-16
c
      do i=1,np
        do j=1,i
          div = a(i,i)*a(j,j)
          if( div .lt. zero ) div = zero
          div = div**0.5  
          if(div.lt.zero) div = zero
          CC(i,j) = a(i,j) / div
          CC(j,i) = CC(i,j)
        enddo 
      enddo 
c
      return
      end
c
c_________________________________________________________________________
c
* subroutine replaces an n by n matrix "a" with the LU
* decomposition of a rowwise permuation of itself
	subroutine ludcmp( a,n,indx,d )
      include 'optim.h'
	double precision  a(ma,ma),indx(n),vv(ma),aamax,sum,dum
	zero = 1.e-16 
	d=1.
c
	do i=1,n
	  aamax=0.
	  do j=1,n
		if(abs(a(i,j)).gt.aamax) aamax = abs(a(i,j))
        enddo
        if(abs(aamax).lt.zero) then
c         'singular matrix'
          d = -999999. 
          return
        endif
        vv(i)=1./aamax
      enddo
c
	do j=1,n
  	  do i=1,j-1
		sum=a(i,j)
		do k=1,i-1
		  sum=sum-a(i,k)*a(k,j)
          enddo
		a(i,j)=sum
        enddo
c
	  aamax=0.
	  do i=j,n
	    sum=a(i,j)
	    do k = 1,j-1
		  sum = sum-a(i,k)*a(k,j)
          enddo
		a(i,j) = sum
		dum = vv(i)*abs(sum)
		if(dum.ge.aamax)then
	 	  imax=i
		  aamax=dum
		endif
        enddo
c
        if(j.ne.imax)then
		do k=1,n
		  dum=a(imax,k)
		  a(imax,k)=a(j,k)
		  a(j,k)=dum
          enddo 
		d=-d
		vv(imax)=vv(j)
	  endif
c
        indx(j)=imax
        if(abs(a(j,j)).lt.zero) a(j,j) = zero
        if(j.ne.n)then
		dum=1./a(j,j)
		do i=j+1,n
		  a(i,j)=a(i,j)*dum
          enddo
        endif
      enddo
c
      return
	end
c
c_________________________________________________________________________
c
c  subroutine solves the set of n linear equations ax=b
c
	subroutine lubksb(a,n,indx,b)
      include 'optim.h'
	double precision  a(ma,ma),indx(n),b(n),sum
c
	ii = 0
	do i = 1,n
	  ll = indx(i)
	  sum = b(ll)
	  b(ll) = b(i)
        if(ii.ne.0)then
		do j = ii,i-1
		  sum = sum - a(i,j)*b(j)
          enddo 
        elseif( sum.ne.0 )then
		ii=i
	  endif
	  b(i) = sum
      enddo 
c
	do i = n,1,-1
        sum = b(i)
	  do j = i+1,n
	    sum = sum-a(i,j)*b(j)
        enddo
        b(i) = sum/a(i,i)
      enddo
c
	return
	end
c
c_________________________________________________________________________
c
	function RMSidm(a,n)
      include 'optim.h'
	dimension  a(ma,ma) 
c
      rmsidm =0.0000
	do i = 1,n
	  a(i,i) = a(i,i) - 1.00
	  do j = 1,n           
		sum = sum + a(i,j)**2
        enddo
      enddo
c
      rmsidm = (sum/n**2)**0.5
c
	return
	end
c
c_________________________________________________________________________
c
      subroutine ErrorByType(otype, res, wgt, nobs, io )
      include 'optim.h'
c
      dimension wgt(mop*2), res(mop),     id(mop)
      dimension nbytyp(mtp1), wtsum(mtp1),  resum(mtp1), wresum(mtp1) 
	dimension wtsum2(mtp1), resum2(mtp1), wresm2(mtp1) 
      character*1  tab
      character*4  otype(mop), otpacc(mtp1) 
	tab = char(9)
	zero = 1.0E-23
c
      do i = 1, mtp1
        otpacc(i) = '????'
        nbytyp(i) = 0
        wtsum2(i) = 0.000
        resum(i)  = 0.000
        wresum(i) = 0.000
        resum2(i) = 0.000
        wresm2(i) = 0.000
	enddo
c  Specify unique types 
      notype=1
      call unique(nobs,notype,otype,id)
      do i = 1,nobs
        if(otpacc(id(i)).eq.'????') otpacc(id(i)) = otype(i)
        if( id(i) .gt. notype )  notype = id(i)
      enddo 
	otpacc(notype+1) = 'ALL '
c
c  Accumulate info by unique types 
c
      do i = 1, nobs
        wgtuse  = wgt(i+nsign(res(i))*mop)
	  if( wgtuse .gt. zero ) then
          do k2 = 1, 2
            k         = id(i)
            if( k2.eq.2 ) k = notype + 1
            wres      = res(i) * wgtuse
            nbytyp(k) = nbytyp(k) + 1
            wtsum(k)  = wtsum(k)  + wgtuse 
            wtsum2(k) = wtsum2(k) + wgtuse**2
            resum(k)  = resum(k)  + res(i)
            wresum(k) = wresum(k) + wres
            resum2(k) = resum2(k) + res(i)**2
            wresm2(k) = wresm2(k) + wres**2
          enddo 
	  endif
      enddo 
c
c   Write header for output
c
      write(io,*)
      write(io,*) 
      write(io,
     + '(a5,a1,a22,a1,a11,a1,a12,a1,a16,a1,a2,a1,a3,a1,a7,a1,a18)')
     + 'CLASS',tab,'Number of Observations',tab,'SS-Weighted',tab,
     + 'RMS-Weighted',tab,'Average-Weighted',tab,'SS',tab,'RMS',tab,
     + 'Average',tab,'Standard Deviation'
c
c  Find Error Stats by observation type  >>>   Write summary to specified I/O
c
      do k = 1, notype + 1
        n = nbytyp(k)
        if( n.ge.1 ) then
	    divn = (n-1)*n
	    if( n.eq.1 ) divn = 1.00
          SD  = ( n*resum2(k) - resum(k)**2 ) / divn
          avg = resum(k) / n
          SS  =  resum2(k) 
          RMS = ( SS / n )**0.5
          Wavg= Wresum(k)  / wtsum(k)
          WSS = wresm2(k) 
          WRMS= (WSS / wtsum(k) )**0.5
c
	    if( k.gt.notype ) write(io,*)
c
          write(io,'(a4,a1,i6,10(a1,g14.7))' )
     +          otpacc(k),tab, n,tab,WSS,tab,WRMS,tab,Wavg,tab,
     +                                SS,tab, RMS,tab, avg,tab,SD  
        else
          write(io,'(a4,a1,i6,10(a1,g14.7))') otpacc(k), n 
        endif
      enddo
c
      write(io,*)
      write(io,*)
c
      return
      end
c
c_________________________________________________________________________
c
