c
c ---------------------------------------------------------
c
      integer function idate2int(date)
	dimension julian(26), rn(80) 
	character*10 date 
	character*2048 txt
      data julian/0,31,59,90,120,151,181,212,243,273,304,334,365,
     +            0,31,60,91,121,152,182,213,244,274,305,335,366/
c
      idate2int = 0
c
      txt = date
      do i = 1, 10
        if( txt(i:i).eq.'/' ) txt(i:i) = ' '
        if( txt(i:i).eq.'-' ) txt(i:i) = ' '
      enddo
c
      call qread(rn,3,txt,ierr) 
c  Reject if 3 values cannot be read 
	if( ierr.gt.0 .or. rn(4).gt.0.5 ) return
c	 
      iyr = rn(3) + 0.5
      iday= rn(2) + 0.5
      mon = rn(1) + 0.5
c   test for 2 digit or 4-digit year
      if( iyr.gt.1899 ) then
        iyr = iyr - 1900
	elseif( iyr.lt.50 ) then
        iyr = iyr + 100
      else 
      endif 
c
      leapcum = (iyr-1)/4  
c
	lepdex = 0
	if( mod(iyr,4).eq.0 ) lepdex = 13 
c
      idate2int = iyr*365 + leapcum + julian(mon+lepdex) + iday + 1
c
      return
      end	
c
c ---------------------------------------------------------
c
      subroutine int2date(idate,date)
	dimension julian(26)
	character*10 date 
      data julian/0,31,59,90,120,151,181,212,243,273,304,334,365,
     +            0,31,60,91,121,152,182,213,244,274,305,335,366/
c
      leapK = mod(idate,1461) - 366
      iyr = (real(idate)-0.5)/365.25 
      if(leapK.eq.0 ) iyr = iyr - 1 
c
      ijds = idate - iyr*365.25
	lepdex = 0
	if( mod(iyr,4).eq.0 ) lepdex = 13 
c
      j = 1
      do while(j.le.12)  
        if( ijds.le.julian(j+lepdex+1) )then
          mon = j
		iday = ijds - julian(j+lepdex)     
          j = 13
        endif
        j = j + 1
      enddo
c
      if( mon.eq.1 .and. iday.eq.0 )then
        mon  = 12
        iday = 31
        iyr  = iyr -1
      endif
c
      iyr = iyr + 1900
      write(date,'(2(i2.2,1h/),i4.4)') mon, iday, iyr
c
      return
      end	
c
c ---------------------------------------------------------
c
      subroutine datecheck(txt,idok)
	character*10 date 
	character*2048 txt, tx2
c
      idok = 0
      tx2 = txt
c
      ks2 = 0 
      ks1 = index(txt,'/' )
      if( ks1.gt.0 ) then 
	  tx2(ks1:ks1) = 'X'
        ks2 = index(tx2,'/')
      else  
        ks1 = index(txt,'-' )
        if( ks1.gt.0 ) then 
	    tx2(ks1:ks1) = 'X'
          ks2 = index(tx2,'-')
        endif
      endif
	kds = ks2 - ks1
c      kds must = 2 or 3
c
      if( kds.gt.1 .and. kds.lt.4 ) then
        if (txt(ks1-1:ks1-1).ne.' '.and. txt(ks2-1:ks2-1).ne.' ' ) then
          kb = ks1-2
  	    read(txt(kb:kb),'(i1)',err=10) i
     	    kb = kb - 1
   10	    kb = kb + 1
     	    ke = kb + 9
  	    date = txt(kb:ke)  
          idok = idate2int(date)
          if( idok.gt.0 ) then
            cumday = idok 
            write(txt(kb:ke),'(f9.0,1x)') cumday
            idok = 1
          endif
        endif
      endif
c
      return
      end	
